## libglacierapp-0.9-2.src.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6.0)

project(glacierapp
        VERSION 1.0.0
	DESCRIPTION "Glacier applications wrapper library")
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

option(BUILD_EXAMPLES "Build the example projects" OFF)

include(FindPkgConfig)
include(FeatureSummary)
include(GNUInstallDirs)
include(QtVersionCompat)

set(QT_MIN_VERSION "5.11.0")
set(QT_LIB_LIST Core Gui Qml Quick)
find_qt_package("${QT_LIB_LIST}" REQUIRED)

if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  set(CMAKE_INSTALL_PREFIX "/usr" CACHE PATH "..." FORCE)
endif()

find_package(PkgConfig)
if(USE_QT6)
pkg_check_modules(MLITE mlite6 IMPORTED_TARGET)
else()
pkg_check_modules(MLITE mlite5 IMPORTED_TARGET)
endif()

if(MLITE_FOUND)
        set_property(GLOBAL APPEND PROPERTY PACKAGES_FOUND mlite)
else()
        set_property(GLOBAL APPEND PROPERTY PACKAGES_NOT_FOUND mlite)
endif()

add_subdirectory(src)
if(MLITE_FOUND)
    add_subdirectory(tools)
endif()

if(BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()

install(FILES
    cmake/modules/QtVersionCompat.cmake
    DESTINATION ${CMAKE_INSTALL_DATADIR}/cmake/Modules
    COMPONENT Devel)

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== examples/CMakeLists.txt ===
set(SRC main.cpp)

if(!USE_QT6)
    find_package(Qt5QuickCompiler)
endif()
qt_add_resources(RESOURCES glacierexample.qrc)

set(PACKAGE glacierexample${LIBGLACIER_PKG_VER})
set(LIB Glacier${LIBGLACIER_PKG_VER}::App)

add_executable(${PACKAGE} ${SRC} ${RESOURCES})

set(QT_LIB_LIST Core Gui Qml Quick)
find_qt_package("${QT_LIB_LIST}" REQUIRED )
add_qt_library(QT_DEPLIBS "${QT_LIB_LIST}")

target_link_libraries(${PACKAGE}
        ${QT_DEPLIBS}
        ${LIB})

install(TARGETS ${PACKAGE} RUNTIME
	DESTINATION ${CMAKE_INSTALL_BINDIR})

=== src/CMakeLists.txt ===
set(SRC glacierapp.cpp)
set(HEADERS glacierapp.h)


set(PACKAGE glacierapp${LIBGLACIER_PKG_VER})
add_library(${PACKAGE} SHARED ${SRC} ${HEADERS})
add_library(Glacier${LIBGLACIER_PKG_VER}::App ALIAS ${PACKAGE})

set(QT_LIB_LIST Core Gui Qml Quick)
find_qt_package("${QT_LIB_LIST}" REQUIRED )
add_qt_library(QT_DEPLIBS "${QT_LIB_LIST}")

if(MLITE_FOUND)
    add_definitions(-DHAS_MLITE5)
    target_link_libraries(${PACKAGE} PUBLIC ${QT_DEPLIBS} PRIVATE PkgConfig::MLITE)
else()
    target_link_libraries(${PACKAGE} ${QT_DEPLIBS})
endif()

target_include_directories(${PACKAGE} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:include/lib${PACKAGE}>)

set_target_properties(${PACKAGE} PROPERTIES
    EXPORT_NAME App
    SOVERSION ${PROJECT_VERSION_MAJOR}
    VERSION ${PROJECT_VERSION})

# Install the library
install(TARGETS ${PACKAGE}
    EXPORT GlacierTargets
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

# Install headers
install(FILES ${HEADERS}
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/lib${PACKAGE}
    COMPONENT Devel)

# Configure and install the pkgconfig file
configure_file(libglacierapp.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/${PACKAGE}.pc
    @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PACKAGE}.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

# Configure and install the CMake Config file
include(CMakePackageConfigHelpers)
set(CMAKECONFIG_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR}/cmake/${PACKAGE}/)

configure_package_config_file(
    "GlacierConfig.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/GlacierConfig.cmake"
    INSTALL_DESTINATION ${CMAKECONFIG_INSTALL_DIR}
    PATH_VARS CMAKE_INSTALL_PREFIX CMAKE_INSTALL_INCLUDEDIR
    CMAKE_INSTALL_LIBDIR NO_CHECK_REQUIRED_COMPONENTS_MACRO)
write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/GlacierConfigVersion.cmake
    VERSION ${glacierapp_VERSION}
    COMPATIBILITY AnyNewerVersion)

install(EXPORT GlacierTargets
    DESTINATION ${CMAKECONFIG_INSTALL_DIR}
    NAMESPACE Glacier::
    COMPONENT Devel)

install(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/GlacierConfig.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/GlacierConfigVersion.cmake"
    DESTINATION ${CMAKECONFIG_INSTALL_DIR}
    COMPONENT Devel)

=== tools/CMakeLists.txt ===
set(SRC libglacierconfig.cpp)

add_executable(glacierconfig ${SRC})

set(QT_LIB_LIST Core Gui Qml Quick)
find_qt_package("${QT_LIB_LIST}" REQUIRED )
add_qt_library(QT_DEPLIBS "${QT_LIB_LIST}")


target_link_libraries(glacierconfig PRIVATE
    Glacier${LIBGLACIER_PKG_VER}::App
    ${QT_DEPLIBS}
    PkgConfig::MLITE)

install(TARGETS glacierconfig RUNTIME
    DESTINATION ${CMAKE_INSTALL_BINDIR})

=== PKGBUILD ===
# Maintainer: Felix Yan <felixonmars@archlinux.org>

pkgname=libglacierapp
pkgver=0.9
pkgrel=2
pkgdesc="Glacier Application library"
arch=('x86_64')
url="https://github.com/nemomobile-ux/libglacierapp"
license=('LGPL')
depends=('mlite' 'qt5-declarative')
makedepends=('cmake')
source=("https://github.com/nemomobile-ux/libglacierapp/archive/$pkgver/$pkgname-$pkgver.tar.gz")
sha512sums=('03b3c761f6e3d7c283f1acfab5de7441df33610df6c349172667c6d0e9ea032675280f12f6ca3861fb143708da1e7618b6fd08bfac596d7988d45c575b711963')

build(){
  cd $pkgname-$pkgver

  cmake -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_INSTALL_LIBDIR=/usr/lib .
  make
}

package() {
  cd $pkgname-$pkgver
  make DESTDIR="$pkgdir" install
}
